module OpenAI.ModelID exposing (ModelID(..), modelIDFromString, stringFromModelID)

{-| 
@docs modelIDFromString, stringFromModelID, ModelID
-}



{-| Autogenerated custom type defining all the `model` values that can be used in the API.

DO NOT edit this file by hand; execute `make cli` instead.
-}
type ModelID
    = Custom String
    | Ada
    | AdaCodeSearchCode
    | AdaCodeSearchText
    | AdaSearchDocument
    | AdaSearchQuery
    | AdaSimilarity
    | Ada_20200503
    | AudioTranscribeDeprecated
    | Babbage
    | BabbageCodeSearchCode
    | BabbageCodeSearchText
    | BabbageSearchDocument
    | BabbageSearchQuery
    | BabbageSimilarity
    | Babbage_20200503
    | CodeCushman001
    | CodeDavinci002
    | CodeDavinciEdit001
    | CodeSearchAdaCode001
    | CodeSearchAdaText001
    | CodeSearchBabbageCode001
    | CodeSearchBabbageText001
    | Curie
    | CurieInstructBeta
    | CurieSearchDocument
    | CurieSearchQuery
    | CurieSimilarity
    | Curie_20200503
    | Cushman_20200503
    | Davinci
    | DavinciIf_300
    | DavinciInstructBeta
    | DavinciInstructBeta_200
    | DavinciSearchDocument
    | DavinciSearchQuery
    | DavinciSimilarity
    | Davinci_20200503
    | IfCurieV2
    | IfDavinciV2
    | IfDavinci_300
    | TextAda001
    | TextAda_001
    | TextBabbage001
    | TextBabbage_001
    | TextCurie001
    | TextCurie_001
    | TextDavinci001
    | TextDavinci002
    | TextDavinci003
    | TextDavinciEdit001
    | TextDavinciInsert001
    | TextDavinciInsert002
    | TextDavinci_001
    | TextEmbeddingAda002
    | TextSearchAdaDoc001
    | TextSearchAdaQuery001
    | TextSearchBabbageDoc001
    | TextSearchBabbageQuery001
    | TextSearchCurieDoc001
    | TextSearchCurieQuery001
    | TextSearchDavinciDoc001
    | TextSearchDavinciQuery001
    | TextSimilarityAda001
    | TextSimilarityBabbage001
    | TextSimilarityCurie001
    | TextSimilarityDavinci001


{-| converts to String; useful for encoding in JSON -}
stringFromModelID : ModelID -> String
stringFromModelID modelId =
    case modelId of
        Custom str ->
            str

        Ada ->
            "ada"

        AdaCodeSearchCode ->
            "ada-code-search-code"

        AdaCodeSearchText ->
            "ada-code-search-text"

        AdaSearchDocument ->
            "ada-search-document"

        AdaSearchQuery ->
            "ada-search-query"

        AdaSimilarity ->
            "ada-similarity"

        Ada_20200503 ->
            "ada:2020-05-03"

        AudioTranscribeDeprecated ->
            "audio-transcribe-deprecated"

        Babbage ->
            "babbage"

        BabbageCodeSearchCode ->
            "babbage-code-search-code"

        BabbageCodeSearchText ->
            "babbage-code-search-text"

        BabbageSearchDocument ->
            "babbage-search-document"

        BabbageSearchQuery ->
            "babbage-search-query"

        BabbageSimilarity ->
            "babbage-similarity"

        Babbage_20200503 ->
            "babbage:2020-05-03"

        CodeCushman001 ->
            "code-cushman-001"

        CodeDavinci002 ->
            "code-davinci-002"

        CodeDavinciEdit001 ->
            "code-davinci-edit-001"

        CodeSearchAdaCode001 ->
            "code-search-ada-code-001"

        CodeSearchAdaText001 ->
            "code-search-ada-text-001"

        CodeSearchBabbageCode001 ->
            "code-search-babbage-code-001"

        CodeSearchBabbageText001 ->
            "code-search-babbage-text-001"

        Curie ->
            "curie"

        CurieInstructBeta ->
            "curie-instruct-beta"

        CurieSearchDocument ->
            "curie-search-document"

        CurieSearchQuery ->
            "curie-search-query"

        CurieSimilarity ->
            "curie-similarity"

        Curie_20200503 ->
            "curie:2020-05-03"

        Cushman_20200503 ->
            "cushman:2020-05-03"

        Davinci ->
            "davinci"

        DavinciIf_300 ->
            "davinci-if:3.0.0"

        DavinciInstructBeta ->
            "davinci-instruct-beta"

        DavinciInstructBeta_200 ->
            "davinci-instruct-beta:2.0.0"

        DavinciSearchDocument ->
            "davinci-search-document"

        DavinciSearchQuery ->
            "davinci-search-query"

        DavinciSimilarity ->
            "davinci-similarity"

        Davinci_20200503 ->
            "davinci:2020-05-03"

        IfCurieV2 ->
            "if-curie-v2"

        IfDavinciV2 ->
            "if-davinci-v2"

        IfDavinci_300 ->
            "if-davinci:3.0.0"

        TextAda001 ->
            "text-ada-001"

        TextAda_001 ->
            "text-ada:001"

        TextBabbage001 ->
            "text-babbage-001"

        TextBabbage_001 ->
            "text-babbage:001"

        TextCurie001 ->
            "text-curie-001"

        TextCurie_001 ->
            "text-curie:001"

        TextDavinci001 ->
            "text-davinci-001"

        TextDavinci002 ->
            "text-davinci-002"

        TextDavinci003 ->
            "text-davinci-003"

        TextDavinciEdit001 ->
            "text-davinci-edit-001"

        TextDavinciInsert001 ->
            "text-davinci-insert-001"

        TextDavinciInsert002 ->
            "text-davinci-insert-002"

        TextDavinci_001 ->
            "text-davinci:001"

        TextEmbeddingAda002 ->
            "text-embedding-ada-002"

        TextSearchAdaDoc001 ->
            "text-search-ada-doc-001"

        TextSearchAdaQuery001 ->
            "text-search-ada-query-001"

        TextSearchBabbageDoc001 ->
            "text-search-babbage-doc-001"

        TextSearchBabbageQuery001 ->
            "text-search-babbage-query-001"

        TextSearchCurieDoc001 ->
            "text-search-curie-doc-001"

        TextSearchCurieQuery001 ->
            "text-search-curie-query-001"

        TextSearchDavinciDoc001 ->
            "text-search-davinci-doc-001"

        TextSearchDavinciQuery001 ->
            "text-search-davinci-query-001"

        TextSimilarityAda001 ->
            "text-similarity-ada-001"

        TextSimilarityBabbage001 ->
            "text-similarity-babbage-001"

        TextSimilarityCurie001 ->
            "text-similarity-curie-001"

        TextSimilarityDavinci001 ->
            "text-similarity-davinci-001"


{-| converts from String; useful for decoding JSON -}
modelIDFromString : String -> ModelID
modelIDFromString str =
    case str of
        "ada" ->
            Ada

        "ada-code-search-code" ->
            AdaCodeSearchCode

        "ada-code-search-text" ->
            AdaCodeSearchText

        "ada-search-document" ->
            AdaSearchDocument

        "ada-search-query" ->
            AdaSearchQuery

        "ada-similarity" ->
            AdaSimilarity

        "ada:2020-05-03" ->
            Ada_20200503

        "audio-transcribe-deprecated" ->
            AudioTranscribeDeprecated

        "babbage" ->
            Babbage

        "babbage-code-search-code" ->
            BabbageCodeSearchCode

        "babbage-code-search-text" ->
            BabbageCodeSearchText

        "babbage-search-document" ->
            BabbageSearchDocument

        "babbage-search-query" ->
            BabbageSearchQuery

        "babbage-similarity" ->
            BabbageSimilarity

        "babbage:2020-05-03" ->
            Babbage_20200503

        "code-cushman-001" ->
            CodeCushman001

        "code-davinci-002" ->
            CodeDavinci002

        "code-davinci-edit-001" ->
            CodeDavinciEdit001

        "code-search-ada-code-001" ->
            CodeSearchAdaCode001

        "code-search-ada-text-001" ->
            CodeSearchAdaText001

        "code-search-babbage-code-001" ->
            CodeSearchBabbageCode001

        "code-search-babbage-text-001" ->
            CodeSearchBabbageText001

        "curie" ->
            Curie

        "curie-instruct-beta" ->
            CurieInstructBeta

        "curie-search-document" ->
            CurieSearchDocument

        "curie-search-query" ->
            CurieSearchQuery

        "curie-similarity" ->
            CurieSimilarity

        "curie:2020-05-03" ->
            Curie_20200503

        "cushman:2020-05-03" ->
            Cushman_20200503

        "davinci" ->
            Davinci

        "davinci-if:3.0.0" ->
            DavinciIf_300

        "davinci-instruct-beta" ->
            DavinciInstructBeta

        "davinci-instruct-beta:2.0.0" ->
            DavinciInstructBeta_200

        "davinci-search-document" ->
            DavinciSearchDocument

        "davinci-search-query" ->
            DavinciSearchQuery

        "davinci-similarity" ->
            DavinciSimilarity

        "davinci:2020-05-03" ->
            Davinci_20200503

        "if-curie-v2" ->
            IfCurieV2

        "if-davinci-v2" ->
            IfDavinciV2

        "if-davinci:3.0.0" ->
            IfDavinci_300

        "text-ada-001" ->
            TextAda001

        "text-ada:001" ->
            TextAda_001

        "text-babbage-001" ->
            TextBabbage001

        "text-babbage:001" ->
            TextBabbage_001

        "text-curie-001" ->
            TextCurie001

        "text-curie:001" ->
            TextCurie_001

        "text-davinci-001" ->
            TextDavinci001

        "text-davinci-002" ->
            TextDavinci002

        "text-davinci-003" ->
            TextDavinci003

        "text-davinci-edit-001" ->
            TextDavinciEdit001

        "text-davinci-insert-001" ->
            TextDavinciInsert001

        "text-davinci-insert-002" ->
            TextDavinciInsert002

        "text-davinci:001" ->
            TextDavinci_001

        "text-embedding-ada-002" ->
            TextEmbeddingAda002

        "text-search-ada-doc-001" ->
            TextSearchAdaDoc001

        "text-search-ada-query-001" ->
            TextSearchAdaQuery001

        "text-search-babbage-doc-001" ->
            TextSearchBabbageDoc001

        "text-search-babbage-query-001" ->
            TextSearchBabbageQuery001

        "text-search-curie-doc-001" ->
            TextSearchCurieDoc001

        "text-search-curie-query-001" ->
            TextSearchCurieQuery001

        "text-search-davinci-doc-001" ->
            TextSearchDavinciDoc001

        "text-search-davinci-query-001" ->
            TextSearchDavinciQuery001

        "text-similarity-ada-001" ->
            TextSimilarityAda001

        "text-similarity-babbage-001" ->
            TextSimilarityBabbage001

        "text-similarity-curie-001" ->
            TextSimilarityCurie001

        "text-similarity-davinci-001" ->
            TextSimilarityDavinci001

        _ ->
            Custom str


